unit IACircleHandle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TIACircleHandleType = (iachtArround,iachtAtUp);
  TIACircleHandle3DStyle = (iach3dsUp,iach3dsDown,iach3dsShadow,iach3dsNone);
  TIACircleHandleTicksStyle = (iachtsAll,iachtsOdds);
  TIACircleHandleHandleStyle = (iachhsRound,iachhsLined);
  TIACircleHandleCaptionPosition = (iachcpLeftTop,iachcpRightTop,iachcpBottomLeft,iachcpBottomRight);
  TIACircleHandleBevelKind = (iachbkUp,iachbkDown,iachbkNone);
  TIACircleHandleDataPosition = (iachdpLeftTop,iachdpCenterTop,iachdpRightTop,
                                 iachdpLeftBottom,iachdpCenterBottom,iachdpRightBottom);
  TIACircleHandleBevelMode = (iachbmTile,iachbmStretch);
  TIACircleHandleNotifyEvent = procedure (Sender: TObject;ItemNumber : integer) of object;
  TIACircleHandle = class(TGraphicControl)
  private
    B1 : TBitmap;
    MainSizeWithout : TSize;
    FDataList: TStringList;
    FEndPosition: Integer;
    FBeginPosition: Integer;
    FTurnClockWise: Boolean;
    FCurrentPosition: Integer;
    FCurrentIndex: Integer;
    FMouseDown : Boolean;
    FHandleType: TIACircleHandleType;
    FLastPosition : TPoint;
    FBackColor: TColor;
    FIs3DShadowColor: TColor;
    FTicksFont: TFont;
    FIs3DLabelStyle: TIACircleHandle3DStyle;
    FIs3DCaptionStyle: TIACircleHandle3DStyle;
    FIs3DTicksStyle: TIACircleHandle3DStyle;
    FInnerRadius: integer;
    FTickLength: integer;
    FGapData: integer;
    FGapCaption: integer;
    FCanResizeMe : Boolean;
    FOldFontChanged : TNotifyEvent;
    FOldTickFontChanged : TNotifyEvent;
    FHandleStyle: TIACircleHandleHandleStyle;
    FTicksStyle: TIACircleHandleTicksStyle;
    FMainBitmap : TBitmap;
    FCaptionPosition: TIACircleHandleCaptionPosition;
    FTickWidth: Integer;
    FTickColor: TColor;
    FTransparencyPercent: integer;
    FPainting : Boolean;
    FLoaded : Boolean;
    FOuterBevelWidth: integer;
    FBorderWidth: integer;
    FOuterDataBevelWidth: integer;
    FBorderDataWidth: integer;
    FInnerBevelWidth: integer;
    FInnerDataBevelWidth: integer;
    FBevelDataColor: TColor;
    FBevelColor: TColor;
    FInnerBevel: TIACircleHandleBevelKind;
    FOuterBevel: TIACircleHandleBevelKind;
    FInnerDataBevel: TIACircleHandleBevelKind;
    FOuterDataBevel: TIACircleHandleBevelKind;
    FLabelPosition: TIACircleHandleDataPosition;
    FBevelDepth : integer;
    FBevelDataDepth : integer;
    FLabelBackColor: TColor;
    FLabelTransparent: Boolean;
    FInvalidateAfterMouseUp: Boolean;
    FBevelLabelSkin: TBitmap;
    FBevelLabelSkinL: TBitmap;
    FBevelLabelSkinD: TBitmap;
    FLabelSkin: TBitmap;
    FBevelSkin: TBitmap;
    FBevelSkinL: TBitmap;
    FBevelSkinD: TBitmap;
    FSkin: TBitmap;
    FBevelskinMode: TIACircleHandleBevelMode;
    FSkinMode: TIACircleHandleBevelMode;
    FBevelLabelSkinMode: TIACircleHandleBevelMode;
    FLabelSkinMode: TIACircleHandleBevelMode;
    FOnSwitch: TIACircleHandleNotifyEvent;
    procedure SetDataList(Value: TStringList);
    procedure SetBeginPosition(Value: Integer);
    procedure SetEndPosition(Value: Integer);
    procedure SetCurrentIndex(Value: Integer);
    procedure SetCurrentPosition(Value: Integer);
    procedure SetTurnClockWise(Value: Boolean);

    procedure WMLBUTTONDOWN(var Message : TMessage); message WM_LBUTTONDOWN;
    procedure WMLBUTTONUP(var Message : TMessage); message WM_LBUTTONUP;
    procedure WMMOUSEMOVE(var Message : TMessage); message WM_MOUSEMOVE;


    procedure FontsChanged(Sender: TObject);
    procedure DefineIndexByPosition;
    procedure DefinePositionByIndex;
    procedure SetHandleType(Value: TIACircleHandleType);
    procedure SetBackColor(Value: TColor);
    procedure SetIs3DCaptionStyle(Value: TIACircleHandle3DStyle);
    procedure SetIs3DLabelStyle(Value: TIACircleHandle3DStyle);
    procedure SetIs3DShadowColor(Value: TColor);
    procedure SetIs3DTicksStyle(Value: TIACircleHandle3DStyle);
    procedure SetTicksFont(Value: TFont);
    function GetHeight: integer;
    function GetWidth: integer;
    procedure SetHeight(Value: integer);
    procedure SetWidth(Value: integer);
    procedure SetInnerRadius(Value: integer);
    procedure SetTickLength(Value: integer);
    procedure SetGapCaption(Value: integer);
    procedure SetGapData(Value: integer);

    procedure GetRealSize;
    procedure RoundPosition;
    procedure NewSize;
    procedure GetBevelDepth;
    procedure GetBevelDataDepth;
    function GetCaption: string;
    procedure SetCaption(Value: string);
    function GetFont: TFont;
    procedure SetFont(Value: TFont);
    procedure SetHandleStyle(Value: TIACircleHandleHandleStyle);
    procedure SetTicksStyle(Value: TIACircleHandleTicksStyle);
    procedure GetMainBitmap;
    procedure DrawMainBitmap;
    procedure SetCaptionPosition(Value: TIACircleHandleCaptionPosition);
    procedure SetTickWidth(Value: Integer);
    procedure SetTickColor(Value: TColor);
    procedure SetTransparencyPercent(Value: integer);
    procedure SetBevelColor(Value: TColor);
    procedure SetBevelDataColor(Value: TColor);
    procedure SetBorderDataWidth(Value: integer);
    procedure SetBorderWidth(Value: integer);
    procedure SetInnerBevel(Value: TIACircleHandleBevelKind);
    procedure SetInnerBevelWidth(Value: integer);
    procedure SetInnerDataBevel(Value: TIACircleHandleBevelKind);
    procedure SetInnerDataBevelWidth(Value: integer);
    procedure SetOuterBevel(Value: TIACircleHandleBevelKind);
    procedure SetOuterBevelWidth(Value: integer);
    procedure SetOuterDataBevel(Value: TIACircleHandleBevelKind);
    procedure SetOuterDataBevelWidth(Value: integer);
    procedure SetLabelPosition(Value: TIACircleHandleDataPosition);
    procedure SetLabelBackColor(Value: TColor);
    procedure SetLabelTransparent(Value: Boolean);
    procedure SetInvalidateAfterMouseUp(Value: Boolean);
    procedure SetBevelLabelSkin(Value: TBitmap);
    procedure SetBevelSkin(Value: TBitmap);
    procedure SetLabelSkin(Value: TBitmap);
    procedure SetSkin(Value: TBitmap);
    procedure SetBevelskinMode(Value: TIACircleHandleBevelMode);
    procedure SetSkinMode(Value: TIACircleHandleBevelMode);
    procedure SetBevelLabelSkinMode(Value: TIACircleHandleBevelMode);
    procedure SetLabelSkinMode(Value: TIACircleHandleBevelMode);
    procedure SetOnSwitch(Value: TIACircleHandleNotifyEvent);
  protected
    procedure Paint; override;
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Resize; override;
  published
    property CurrentIndex : Integer read FCurrentIndex write SetCurrentIndex default 0;
    property TransparencyPercent : integer read FTransparencyPercent write SetTransparencyPercent default 45;
    property DataList : TStringList read FDataList write SetDataList;
    property BeginPosition : Integer read FBeginPosition write SetBeginPosition default 800;
    property EndPosition : Integer read FEndPosition write SetEndPosition default -100;
    property CurrentPosition : Integer read FCurrentPosition write SetCurrentPosition default 100;

    property TurnClockWise : Boolean read FTurnClockWise write SetTurnClockWise default TRUE;
    property HandleType : TIACircleHandleType read FHandleType write SetHandleType default iachtArround;
    property Is3DCaptionStyle : TIACircleHandle3DStyle read FIs3DCaptionStyle write SetIs3DCaptionStyle default iach3dsNone;
    property Is3DTicksStyle   : TIACircleHandle3DStyle read FIs3DTicksStyle write SetIs3DTicksStyle default iach3dsNone;
    property Is3DLabelStyle   : TIACircleHandle3DStyle read FIs3DLabelStyle write SetIs3DLabelStyle default iach3dsNone;
    property TicksFont : TFont read FTicksFont write SetTicksFont;
    property Is3DShadowColor : TColor read FIs3DShadowColor write SetIs3DShadowColor default clGray;
    property BackColor : TColor read FBackColor write SetBackColor default clGray;
    property Width : integer read GetWidth write SetWidth;
    property Height : integer read GetHeight write SetHeight;
    property InnerRadius : integer read FInnerRadius write SetInnerRadius default 20;
    property TickLength : integer read FTickLength write SetTickLength default 10;
    property GapCaption : integer read FGapCaption write SetGapCaption;
    property GapData : integer read FGapData write SetGapData;
    property TicksStyle : TIACircleHandleTicksStyle read FTicksStyle write SetTicksStyle default iachtsAll;
    property HandleStyle : TIACircleHandleHandleStyle read FHandleStyle write SetHandleStyle default iachhsRound;
    property CaptionPosition : TIACircleHandleCaptionPosition read FCaptionPosition write SetCaptionPosition default iachcpLeftTop;
    property TickWidth : Integer read FTickWidth write SetTickWidth default 1;
    property TickColor : TColor read FTickColor write SetTickColor default clBlack;
    property InnerBevel : TIACircleHandleBevelKind read FInnerBevel write SetInnerBevel default iachbkDown;
    property OuterBevel : TIACircleHandleBevelKind read FOuterBevel write SetOuterBevel default iachbkUp;
    property InnerDataBevel : TIACircleHandleBevelKind read FInnerDataBevel write SetInnerDataBevel default iachbkDown;
    property OuterDataBevel : TIACircleHandleBevelKind read FOuterDataBevel write SetOuterDataBevel default iachbkUp;
    property InnerBevelWidth : integer read FInnerBevelWidth write SetInnerBevelWidth default 2;
    property OuterBevelWidth : integer read FOuterBevelWidth write SetOuterBevelWidth default 2;
    property InnerDataBevelWidth : integer read FInnerDataBevelWidth write SetInnerDataBevelWidth default 2;
    property OuterDataBevelWidth : integer read FOuterDataBevelWidth write SetOuterDataBevelWidth default 2;
    property BorderWidth : integer read FBorderWidth write SetBorderWidth default 2;
    property BorderDataWidth : integer read FBorderDataWidth write SetBorderDataWidth default 2;
    property BevelColor : TColor read FBevelColor write SetBevelColor default clGray;
    property BevelDataColor : TColor read FBevelDataColor write SetBevelDataColor default clGray;
    property LabelPosition : TIACircleHandleDataPosition read FLabelPosition write SetLabelPosition default iachdpCenterTop;
    property LabelBackColor : TColor read FLabelBackColor write SetLabelBackColor default clSilver;
    property LabelTransparent : Boolean read FLabelTransparent write SetLabelTransparent default false;
    property InvalidateAfterMouseUp : Boolean read FInvalidateAfterMouseUp write SetInvalidateAfterMouseUp default false;

    property Caption : string read GetCaption write SetCaption;
    property Color;
    property Font : TFont read GetFont write SetFont;
    property Enabled;
    property Align;
    property Anchors;
    property Constraints;
    property Visible;

    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;

    property Skin : TBitmap read FSkin write SetSkin;
    property BevelSkin : TBitmap read FBevelSkin write SetBevelSkin;
    property LabelSkin : TBitmap read FLabelSkin write SetLabelSkin;
    property BevelLabelSkin : TBitmap read FBevelLabelSkin write SetBevelLabelSkin;
    property SkinMode : TIACircleHandleBevelMode read FSkinMode write SetSkinMode default iachbmTile;
    property BevelSkinMode : TIACircleHandleBevelMode read FBevelskinMode write SetBevelskinMode default iachbmTile;
    property LabelSkinMode : TIACircleHandleBevelMode read FLabelSkinMode write SetLabelSkinMode default iachbmTile;
    property BevelLabelSkinMode : TIACircleHandleBevelMode read FBevelLabelSkinMode write SetBevelLabelSkinMode default iachbmTile;
    property OnSwitch : TIACircleHandleNotifyEvent read FOnSwitch write SetOnSwitch;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('TIA', [TIACircleHandle]);
end;
function GetDColor(Value : Tcolor): Tcolor;
var
  pR,pB,pG : pByte;
begin
  result:=colortoRGB(Value);
  pR:=@result;
  pG:=pByte(integer(pR)+1);
  pB:=pByte(integer(pG)+1);
  if pR^<32 then pR^:=0 else dec(pR^,32);
  if pG^<32 then pG^:=0 else dec(pG^,32);
  if pB^<32 then pB^:=0 else dec(pB^,32);
end;
function GetLColor(Value : Tcolor): Tcolor;
var
  pR,pB,pG : pByte;
begin
  result:=colortoRGB(Value);
  pR:=@result;
  pG:=pByte(integer(pR)+1);
  pB:=pByte(integer(pG)+1);
  if pR^>223 then pR^:=255 else inc(pR^,32);
  if pG^>223 then pG^:=255 else inc(pG^,32);
  if pB^>223 then pB^:=255 else inc(pB^,32);
end;
procedure Dark24Bitmap(var B : TBitmap;N : integer);
var
  i,j : integer;
  pB : PByteArray;
begin
  for i:=0 to B.Height-1 do
   begin
     pb:=B.ScanLine[i];
     for j:=0 to 3*B.Width-1 do
       begin
         if pb[j]<n then pb[j]:=0 else dec(pb[j],n);
       end;
   end;
end;
procedure Light24Bitmap(var B : TBitmap;N : integer);
var
  i,j : integer;
  pB : PByteArray;
begin
  for i:=0 to B.Height-1 do
   begin
     pb:=B.ScanLine[i];
     for j:=0 to 3*B.Width-1 do
       begin
         if pb[j]>(255-n) then pb[j]:=255 else inc(pb[j],n);
       end;
   end;
end;
{ TIACircleHandle }


constructor TIACircleHandle.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOnSwitch:=nil;
  FLoaded:=false;
  FDataList:=TStringList.Create;
  FDataList.Add('1 ms');
  FDataList.Add('2 ms');
  FDataList.Add('5 ms');
  FDataList.Add('10 ms');
  FDataList.Add('20 ms');
  FDataList.Add('50 ms');
  FMouseDown:=false;
  FEndPosition:=-100;
  FBeginPosition:=800;
  FTurnClockWise:=True;
  FCurrentPosition:=100;
  FCurrentIndex:=0;
  FHandleType:=iachtArround;
  FTicksFont:=TFont.Create;

  FBackColor:=clGray;
  FIs3DShadowColor:=clGray;
  FIs3DLabelStyle:=iach3dsUp;
  FIs3DCaptionStyle:=iach3dsUP;
  FIs3DTicksStyle:=iach3dsUp;
  inherited Width:=128;
  inherited Height:=128;
  FInnerRadius:=20;
  FTickLength:=10;


  FCanResizeMe:=TRUE;
  FOldFontChanged :=Font.OnChange;
  FOldTickFontChanged := FTicksFont.OnChange;
  inherited Font.OnChange:=FontsChanged;
  FTicksFont.OnChange:=FontsChanged;
  FHandleStyle:= iachhsRound;
  FTicksStyle:=iachtsAll;
  FMainBitmap:=TBitmap.Create;
  FMainbitmap.PixelFormat:=pf24bit;
  FMainBitmap.Width:=40;
  FMainBitmap.Height:=40;
  FCaptionPosition:=iachcpLeftTop;
  FTickWidth:=1;
  FTickColor:=clBlack;
  FTransparencyPercent:=45;
  FPainting:=false;

  FBevelSkin:=TBitmap.Create;
  FBevelSkin.PixelFormat:=pf24Bit;
  FBevelSkin.Height:=0;
  FBevelSkin.Width:=0;
  FBevelSkinL:=TBitmap.Create;
  FBevelSkinL.PixelFormat:=pf24Bit;
  FBevelSkinL.Height:=0;
  FBevelSkinL.Width:=0;
  FBevelSkinD:=TBitmap.Create;
  FBevelSkinD.PixelFormat:=pf24Bit;
  FBevelSkinD.Height:=0;
  FBevelSkinD.Width:=0;

  FLabelSkin:=TBitmap.Create;
  FLabelSkin.PixelFormat:=pf24Bit;
  FLabelSkin.Height:=0;
  FLabelSkin.Width:=0;

  FBevelLabelSkin:=TBitmap.Create;
  FBevelLabelSkin.PixelFormat:=pf24Bit;
  FBevelLabelSkin.Height:=0;
  FBevelLabelSkin.Width:=0;
  FBevelLabelSkinL:=TBitmap.Create;
  FBevelLabelSkinL.PixelFormat:=pf24Bit;
  FBevelLabelSkinL.Height:=0;
  FBevelLabelSkinL.Width:=0;
  FBevelLabelSkinD:=TBitmap.Create;
  FBevelLabelSkinD.PixelFormat:=pf24Bit;
  FBevelLabelSkinD.Height:=0;
  FBevelLabelSkinD.Width:=0;


  FSkin:=TBitmap.Create;
  FSkin.PixelFormat:=pf24Bit;
  FSkin.Height:=0;
  FSkin.Width:=0;

  FBevelskinMode:=iachbmTile;
  FSkinMode:=iachbmTile;
  FBevelLabelSkinMode:=iachbmTile;
  FLabelSkinMode:=iachbmTile;

  FOuterBevelWidth:=2;
  FBorderWidth:=2;
  FOuterDataBevelWidth:=2;
  FBorderDataWidth:=2;
  FInnerBevelWidth:=2;
  FInnerDataBevelWidth:=2;
  FBevelDataColor:=clGray;
  FBevelColor:=clGray;
  FInnerBevel:= iachbkDown;
  FOuterBevel:= iachbkUp;
  FInnerDataBevel:= iachbkDown;
  FOuterDataBevel:= iachbkUp;
  FLabelPosition:=iachdpCenterTop;
  FBevelDepth:=6;
  FBevelDataDepth:=6;
  FLabelBackColor:=clSilver;
  FLabelTransparent:=false;
  B1:=TBitmap.create;
  B1.PixelFormat:=pf24bit;
  B1.Width:=Width;
  B1.Height:=Height;
  FInvalidateAfterMouseUp:=false;
  Color:=RGb(140,140,140);
  definepositionbyindex;
  FInnerRadius:=32;
  NewSize;
end;

procedure TIACircleHandle.DefineIndexByPosition;
var dA,cp : integer;
begin
  if FTurnClockWise then
  begin
    da:=FEndPosition-FbeginPosition;
    while da<0 do inc(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=FCurrentPosition-FBeginPosition;
    while cp<0 do inc(cp,3600);
    FCurrentIndex:=round(cp/da);
    if FCurrentIndex>=FDatalist.count then FCurrentIndex:=FDatalist.count-1;
    if FCurrentIndex<0 then FCurrentIndex:=0;
  end else
  begin
    da:=FEndPosition-FbeginPosition;
    while da>0 do dec(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=FCurrentPosition-FBeginPosition;
    while cp>0 do dec(cp,3600);
    FCurrentIndex:=round(cp/da);
    if FCurrentIndex>=FDatalist.count then FCurrentIndex:=FDatalist.count-1;
    if FCurrentIndex<0 then FCurrentIndex:=0;
  end;
end;

procedure TIACircleHandle.DefinePositionByIndex;
var dA,cp : integer;
begin
  if FTurnClockWise then
  begin
    da:=FEndPosition-FbeginPosition;
    while da<0 do inc(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=da*FCurrentIndex+FBeginPosition;
    while cp> 1800 do dec(cp,3600);
    while cp<=-1800 do inc(cp,3600);
    FCurrentPosition:=cp;
  end else
  begin
    da:=FEndPosition-FbeginPosition;
    while da>0 do dec(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=da*FCurrentIndex+FBeginPosition;
    while cp> 1800 do dec(cp,3600);
    while cp<=-1800 do inc(cp,3600);
    FCurrentPosition:=cp;
  end;
end;

destructor TIACircleHandle.Destroy;
begin
  Font.OnChange:=FOldFontChanged;
  FTicksFont.OnChange:=FOldTickFontChanged;
  FTicksFont.free;
  FMainBitmap.free;
  FDataList.free;
  B1.free;
  FBevelSkin.free;
  FBevelSkinL.free;
  FBevelSkinD.free;
  FSkin.free;
  FBevelLabelSkin.free;
  FBevelLabelSkinL.free;
  FBevelLabelSkinD.free;
  FLabelSkin.free;
  inherited Destroy;
end;

procedure TIACircleHandle.DrawMainBitmap;
var i,da,dx,dy,MaxX,MaxY,a,x0,y0,j,x1,y1,dw,dh : integer;
    sz : TSize;
    B1 : TBitmap;
    p1,p2 : pByteArray;
    pt : array [1..6] of Tpoint;
    RGN,RGNL,RGND : HRGN;
begin
  if (FTransparencyPercent<=100)  then
    begin
      B1:=TBitmap.Create;
      B1.Width:=FMainBitmap.Width;
      B1.Height:=FMainBitmap.Height;
      B1.PixelFormat:=pf24bit;

      B1.Canvas.brush.Color:=FBevelColor;
      B1.Canvas.FillRect(rect(0,0,B1.width,B1.height));
      B1.Canvas.brush.Color:=fBackColor;
      if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then
        begin
          case FBevelSkinMode of
            iachbmTile :
              begin
                for i:=0 to b1.height div FBevelSkin.height do
                  for j:=0 to b1.width div FBevelSkin.width do
                    B1.canvas.Draw(j*FBevelSkin.width,i*FBevelSkin.height,FBevelSkin);
              end;
            iachbmStretch :
              begin
                B1.Canvas.StretchDraw(rect(0,0,B1.width,b1.height),FBevelSkin);
              end;
          end;

        end;
      B1.Canvas.FillRect(rect(FBevelDepth,FBevelDepth,B1.width-FBevelDepth,B1.height-FBevelDepth));
      if (FSkin.Height<>0) and (FSkin.width<>0) then
        begin
          RGN:=CreaterectRGN(FBevelDepth,FBevelDepth,B1.width-FBevelDepth,B1.height-FBevelDepth);
          selectcliprgn(B1.Canvas.handle,RGN);
          case FSkinMode of
            iachbmTile :
              begin
                for i:=0 to b1.height div FSkin.height do
                  for j:=0 to b1.width div FSkin.width do
                    B1.canvas.Draw(j*FSkin.width,i*FSkin.height,FSkin);
              end;
            iachbmStretch :
              begin
                B1.Canvas.StretchDraw(rect(0,0,B1.width,b1.height),FSkin);
              end;
          end;
          selectcliprgn(B1.Canvas.handle,0);
          deleteobject(RGN);
        end;
      RGNL:=createrectRGN(0,0,0,0);RGND:=createrectRGN(0,0,0,0);
      case FOuterBevel of
        iachbkUp :
          begin
            B1.Canvas.brush.Color:=GetLColor(FBevelColor);
            pt[1].x:=0;                                  pt[1].y:=B1.height;
            pt[2].x:=0;                                  pt[2].y:=0;
            pt[3].x:=B1.width;                           pt[3].y:=0;
            pt[4].x:=B1.width-FOuterBevelWidth;          pt[4].y:=FOuterBevelWidth;
            pt[5].x:=FOuterBevelWidth;                   pt[5].y:=FOuterBevelWidth;
            pt[6].x:=FOuterBevelWidth;                   pt[6].y:=B1.height-FOuterBevelWidth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);

            B1.Canvas.brush.Color:=GetDColor(FBevelColor);
            pt[1].x:=B1.width;                                  pt[1].y:=0;
            pt[2].x:=B1.width;                                  pt[2].y:=B1.height;
            pt[3].x:=0;                                         pt[3].y:=B1.height;
            pt[4].x:=FOuterBevelWidth;                          pt[4].y:=B1.height-FOuterBevelWidth;
            pt[5].x:=B1.width-FOuterBevelWidth;                 pt[5].y:=B1.height-FOuterBevelWidth;
            pt[6].x:=B1.width-FOuterBevelWidth;                 pt[6].y:=FOuterBevelWidth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);

          end;
        iachbkDown :
          begin
            B1.Canvas.brush.Color:=GetDColor(FBevelColor);
            pt[1].x:=0;                                  pt[1].y:=B1.height;
            pt[2].x:=0;                                  pt[2].y:=0;
            pt[3].x:=B1.width;                           pt[3].y:=0;
            pt[4].x:=B1.width-FOuterBevelWidth;          pt[4].y:=FOuterBevelWidth;
            pt[5].x:=FOuterBevelWidth;                   pt[5].y:=FOuterBevelWidth;
            pt[6].x:=FOuterBevelWidth;                   pt[6].y:=B1.height-FOuterBevelWidth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);

            B1.Canvas.brush.Color:=GetLColor(FBevelColor);
            pt[1].x:=B1.width;                                  pt[1].y:=0;
            pt[2].x:=B1.width;                                  pt[2].y:=B1.height;
            pt[3].x:=0;                                         pt[3].y:=B1.height;
            pt[4].x:=FOuterBevelWidth;                          pt[4].y:=B1.height-FOuterBevelWidth;
            pt[5].x:=B1.width-FOuterBevelWidth;                 pt[5].y:=B1.height-FOuterBevelWidth;
            pt[6].x:=B1.width-FOuterBevelWidth;                 pt[6].y:=FOuterBevelWidth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);
          end;
      end;
      case FInnerBevel of
        iachbkUp :
          begin
            B1.Canvas.brush.Color:=GetLColor(FBevelColor);
            pt[1].x:=FBevelDepth-FInnerBevelWidth;                pt[1].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[2].x:=FBevelDepth-FInnerBevelWidth;                pt[2].y:=FBevelDepth-FInnerBevelWidth;
            pt[3].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[3].y:=FBevelDepth-FInnerBevelWidth;
            pt[4].x:=B1.width-FBevelDepth;                        pt[4].y:=FBevelDepth;
            pt[5].x:=FBevelDepth;                                 pt[5].y:=FBevelDepth;
            pt[6].x:=FBevelDepth;                                 pt[6].y:=B1.height-FBevelDepth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);

            B1.Canvas.brush.Color:=GetDColor(FBevelColor);
            pt[1].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[1].y:=FBevelDepth-FInnerBevelWidth;
            pt[2].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[2].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[3].x:=FBevelDepth-FInnerBevelWidth;                pt[3].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[4].x:=FBevelDepth;                                 pt[4].y:=B1.height-FBevelDepth;
            pt[5].x:=B1.width-FBevelDepth;                        pt[5].y:=B1.height-FBevelDepth;
            pt[6].x:=B1.width-FBevelDepth;                        pt[6].y:=FBevelDepth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);
          end;
        iachbkDown :
          begin
            B1.Canvas.brush.Color:=GetDColor(FBevelColor);
            pt[1].x:=FBevelDepth-FInnerBevelWidth;                pt[1].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[2].x:=FBevelDepth-FInnerBevelWidth;                pt[2].y:=FBevelDepth-FInnerBevelWidth;
            pt[3].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[3].y:=FBevelDepth-FInnerBevelWidth;
            pt[4].x:=B1.width-FBevelDepth;                        pt[4].y:=FBevelDepth;
            pt[5].x:=FBevelDepth;                                 pt[5].y:=FBevelDepth;
            pt[6].x:=FBevelDepth;                                 pt[6].y:=B1.height-FBevelDepth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);

            B1.Canvas.brush.Color:=GetLColor(FBevelColor);
            pt[1].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[1].y:=FBevelDepth-FInnerBevelWidth;
            pt[2].x:=B1.width-FBevelDepth+FInnerBevelWidth;       pt[2].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[3].x:=FBevelDepth-FInnerBevelWidth;                pt[3].y:=B1.height-FBevelDepth+FInnerBevelWidth;
            pt[4].x:=FBevelDepth;                                 pt[4].y:=B1.height-FBevelDepth;
            pt[5].x:=B1.width-FBevelDepth;                        pt[5].y:=B1.height-FBevelDepth;
            pt[6].x:=B1.width-FBevelDepth;                        pt[6].y:=FBevelDepth;
            RGN:=CreatePolygonRGN(pt,6,Alternate);
            if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
            fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
            deleteobject(RGN);
          end;
      end;
      if (FBevelSkin.Height<>0) and (FBevelSkin.width<>0) then
        begin
          selectcliprgn(B1.Canvas.handle,RGNL);
          case FBevelSkinMode of
            iachbmTile :
              begin
                for i:=0 to b1.height div FBevelSkin.height do
                  for j:=0 to b1.width div FBevelSkin.width do
                    B1.canvas.Draw(j*FBevelSkin.width,i*FBevelSkin.height,FBevelSkinL);
              end;
            iachbmStretch :
              begin
                B1.Canvas.StretchDraw(rect(0,0,B1.width,b1.height),FBevelSkinL);
              end;
          end;
          selectcliprgn(B1.Canvas.handle,0);
          selectcliprgn(B1.Canvas.handle,RGND);
          case FBevelSkinMode of
            iachbmTile :
              begin
                for i:=0 to b1.height div FBevelSkin.height do
                  for j:=0 to b1.width div FBevelSkin.width do
                    B1.canvas.Draw(j*FBevelSkin.width,i*FBevelSkin.height,FBevelSkinD);
              end;
            iachbmStretch :
              begin
                B1.Canvas.StretchDraw(rect(0,0,B1.width,b1.height),FBevelSkinD);
              end;
          end;
          selectcliprgn(B1.Canvas.handle,0);
        end;
      deleteobject(RGNL);
      deleteobject(RGND);
      x1:=0;y1:=0;dw:=0;dh:=0;
      if FHandleType=iachtAtUp then
        begin
          MaxX:=0;MaxY:=0;
          B1.canvas.Font.Assign(self.TicksFont);
          for i:=0 to  FDataList.Count-1 do
            begin
              GetTextExtentPoint32(B1.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
              if MaxX<sz.cx then MaxX:=sz.cx;
              if MaxY<sz.cy then MaxY:=sz.cy;
            end;
          B1.Canvas.Font.Assign(Font);
          GetTextExtentPoint32(B1.canvas.handle,@(Caption[1]),length(Caption),sz);
          B1.canvas.Font.Assign(self.TicksFont);
          dw:=maxX+2*FBevelDataDepth;
          dh:=maxY+2*FBevelDataDepth; x1:=0;y1:=0;
          case FLabelPosition of
            iachdpLeftTop :
              begin
                case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=FBevelDepth;y1:=FBevelDepth+ sz.cy+FGapCaption;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=FBevelDepth;y1:=FBevelDepth;
                    end;
                end;
              end;
            iachdpCenterTop :
              begin
               case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=b1.width div 2-dw div 2;y1:=FBevelDepth+ sz.cy+FGapCaption;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=b1.width div 2-dw div 2;y1:=FBevelDepth;
                    end;
                end;
              end;
            iachdpRightTop :
              begin
                case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=b1.width-FBevelDepth-dw;y1:=FBevelDepth+ sz.cy+FGapCaption;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=b1.width-FBevelDepth-dw;y1:=FBevelDepth;
                    end;
                end;
              end;
            iachdpLeftBottom :
              begin
                case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=FBevelDepth;y1:=b1.height-FBevelDepth-dh;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=FBevelDepth;y1:=b1.height-FBevelDepth-dh-sz.cy-FGapCaption;
                    end;
                end;
              end;
            iachdpCenterBottom :
              begin
                case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=b1.width div 2-dw div 2;y1:=b1.height-FBevelDepth-dh;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=b1.width div 2-dw div 2;y1:=b1.height-FBevelDepth-dh-sz.cy-FGapCaption;
                    end;
                end;
              end;
            iachdpRightBottom :
              begin
                case FCaptionPosition of
                  iachcpLeftTop,iachcpRightTop :
                    begin
                      x1:=b1.width-FBevelDepth-dw;y1:=b1.height-FBevelDepth-dh;
                    end;
                  iachcpBottomLeft,iachcpBottomRight :
                    begin
                      x1:=b1.width-FBevelDepth-dw;y1:=b1.height-FBevelDepth-dh-sz.cy-FGapCaption;
                    end;
                end;
              end;
          end;
          // we define the position...
          B1.Canvas.brush.Color:=FBevelDataColor;
          B1.Canvas.FillRect(rect(x1,y1,x1+dw,y1+dh));
          if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then
            begin
              RGN:=CreaterectRGN(x1,y1,x1+dw,y1+dh);
              selectcliprgn(B1.Canvas.handle,RGN);
              case FBevelLabelSkinMode of
                iachbmTile :
                  begin
                    for i:=0 to dh div FBevelLabelSkin.height do
                      for j:=0 to dw div FBevelLabelSkin.width do
                        B1.canvas.Draw(j*FBevelLabelSkin.width+x1,i*FBevelLabelSkin.height+y1,FBevelLabelSkin);
                  end;
                iachbmStretch :
                  begin
                    B1.Canvas.StretchDraw(rect(x1,y1,x1+dw,y1+dh),FBevelLabelSkin);
                  end;

              end;
              selectcliprgn(B1.Canvas.handle,0);
              deleteobject(RGN);
            end;
          if FLabelTransparent then
            begin
              B1.Canvas.brush.Color:=fLabelBackColor;
              B1.Canvas.FillRect(rect(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth));
              if (FLabelSkin.Height<>0) and (FLabelSkin.width<>0) then
                begin
                  RGN:=CreaterectRGN(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth);
                  selectcliprgn(B1.Canvas.handle,RGN);
                  case FLabelSkinMode of
                    iachbmTile :
                      begin
                        for i:=0 to MaxY div FLabelSkin.height do
                          for j:=0 to MaxX div FLabelSkin.width do
                            B1.canvas.Draw(j*FLabelSkin.width+x1+FBeveldataDepth,i*FLabelSkin.height+y1+FBeveldataDepth,FLabelSkin);
                      end;
                    iachbmStretch :
                      begin
                        B1.Canvas.StretchDraw(rect(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth),FLabelSkin);
                      end;
                  end;
                  selectcliprgn(B1.Canvas.handle,0);
                  deleteobject(RGN);
                end;
            end;
          //---
          RGNL:=createrectRGN(0,0,0,0);RGND:=createrectRGN(0,0,0,0);
          case FOuterDataBevel of
            iachbkUp :
              begin
                B1.Canvas.brush.Color:=GetLColor(FBeveldataColor);
                pt[1].x:=x1;                                  pt[1].y:=y1+dh;
                pt[2].x:=x1;                                  pt[2].y:=y1;
                pt[3].x:=x1+dw;                               pt[3].y:=y1;
                pt[4].x:=x1+dw-FOuterDataBevelWidth;          pt[4].y:=y1+FOuterDataBevelWidth;
                pt[5].x:=x1+FOuterDataBevelWidth;             pt[5].y:=y1+FOuterDataBevelWidth;
                pt[6].x:=x1+FOuterDataBevelWidth;             pt[6].y:=y1+dh-FOuterDataBevelWidth;
                RGN:=CreatePolygonRGN(pt,6,Alternate);
                if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
                fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
                deleteobject(RGN);

                B1.Canvas.brush.Color:=GetDColor(FBevelDataColor);
                pt[1].x:=x1+dw;                                  pt[1].y:=y1;
                pt[2].x:=x1+dw;                                  pt[2].y:=y1+dh;
                pt[3].x:=x1;                                     pt[3].y:=y1+dh;
                pt[4].x:=x1+FOuterDataBevelWidth;                pt[4].y:=y1+dh-FOuterDataBevelWidth;
                pt[5].x:=x1+dw-FOuterDataBevelWidth;             pt[5].y:=y1+dh-FOuterDataBevelWidth;
                pt[6].x:=x1+dw-FOuterDataBevelWidth;             pt[6].y:=y1+FOuterDataBevelWidth;
                RGN:=CreatePolygonRGN(pt,6,Alternate);
                if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
                fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
                deleteobject(RGN);

              end;
            iachbkDown :
              begin
                B1.Canvas.brush.Color:=GetDColor(FBeveldataColor);
                pt[1].x:=x1;                                  pt[1].y:=y1+dh;
                pt[2].x:=x1;                                  pt[2].y:=y1;
                pt[3].x:=x1+dw;                               pt[3].y:=y1;
                pt[4].x:=x1+dw-FOuterDataBevelWidth;          pt[4].y:=y1+FOuterDataBevelWidth;
                pt[5].x:=x1+FOuterDataBevelWidth;             pt[5].y:=y1+FOuterDataBevelWidth;
                pt[6].x:=x1+FOuterDataBevelWidth;             pt[6].y:=y1+dh-FOuterDataBevelWidth;
                RGN:=CreatePolygonRGN(pt,6,Alternate);
                if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
                fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
                deleteobject(RGN);

                B1.Canvas.brush.Color:=GetLColor(FBevelDataColor);
                pt[1].x:=x1+dw;                                  pt[1].y:=y1;
                pt[2].x:=x1+dw;                                  pt[2].y:=y1+dh;
                pt[3].x:=x1;                                     pt[3].y:=y1+dh;
                pt[4].x:=x1+FOuterDataBevelWidth;                pt[4].y:=y1+dh-FOuterDataBevelWidth;
                pt[5].x:=x1+dw-FOuterDataBevelWidth;             pt[5].y:=y1+dh-FOuterDataBevelWidth;
                pt[6].x:=x1+dw-FOuterDataBevelWidth;             pt[6].y:=y1+FOuterDataBevelWidth;
                RGN:=CreatePolygonRGN(pt,6,Alternate);
                if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
                fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
                deleteobject(RGN);
              end;
          end;
        case FInnerDataBevel of
          iachbkUp :
            begin
              B1.Canvas.brush.Color:=GetLColor(FBevelDataColor);
              pt[1].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;      pt[1].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[2].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;      pt[2].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[3].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;   pt[3].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[4].x:=x1+dw-FBevelDataDepth;                        pt[4].y:=y1+FBevelDataDepth;
              pt[5].x:=x1+FBevelDataDepth;                           pt[5].y:=y1+FBevelDataDepth;
              pt[6].x:=x1+FBevelDataDepth;                           pt[6].y:=y1+dh-FBevelDataDepth;
              RGN:=CreatePolygonRGN(pt,6,Alternate);
              if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
              fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
              deleteobject(RGN);

              B1.Canvas.brush.Color:=GetDColor(FBevelDataColor);
              pt[1].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;       pt[1].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[2].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;       pt[2].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[3].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;          pt[3].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[4].x:=x1+FBevelDataDepth;                               pt[4].y:=y1+dh-FBevelDataDepth;
              pt[5].x:=x1+dw-FBevelDataDepth;                            pt[5].y:=y1+dh-FBevelDataDepth;
              pt[6].x:=x1+dw-FBevelDataDepth;                            pt[6].y:=y1+FBevelDataDepth;
              RGN:=CreatePolygonRGN(pt,6,Alternate);
              if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
              fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
              deleteobject(RGN);
            end;
          iachbkDown :
            begin
              B1.Canvas.brush.Color:=GetDColor(FBevelDataColor);
              pt[1].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;      pt[1].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[2].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;      pt[2].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[3].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;   pt[3].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[4].x:=x1+dw-FBevelDataDepth;                        pt[4].y:=y1+FBevelDataDepth;
              pt[5].x:=x1+FBevelDataDepth;                           pt[5].y:=y1+FBevelDataDepth;
              pt[6].x:=x1+FBevelDataDepth;                           pt[6].y:=y1+dh-FBevelDataDepth;
              RGN:=CreatePolygonRGN(pt,6,Alternate);
              if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGND,RGND,RGN,RGN_OR) else
              fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
              deleteobject(RGN);

              B1.Canvas.brush.Color:=GetLColor(FBevelDataColor);
              pt[1].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;       pt[1].y:=y1+FBevelDataDepth-FInnerDataBevelWidth;
              pt[2].x:=x1+dw-FBevelDataDepth+FInnerDataBevelWidth;       pt[2].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[3].x:=x1+FBevelDataDepth-FInnerDataBevelWidth;          pt[3].y:=y1+dh-FBevelDataDepth+FInnerDataBevelWidth;
              pt[4].x:=x1+FBevelDataDepth;                               pt[4].y:=y1+dh-FBevelDataDepth;
              pt[5].x:=x1+dw-FBevelDataDepth;                            pt[5].y:=y1+dh-FBevelDataDepth;
              pt[6].x:=x1+dw-FBevelDataDepth;                            pt[6].y:=y1+FBevelDataDepth;
              RGN:=CreatePolygonRGN(pt,6,Alternate);
              if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then combinergn(RGNL,RGNL,RGN,RGN_OR) else
              fillrgn(B1.canvas.handle,RGN,B1.canvas.brush.handle);
              deleteobject(RGN);
            end;
        end;
          if (FBevelLabelSkin.Height<>0) and (FBevelLabelSkin.width<>0) then
            begin
              selectcliprgn(B1.Canvas.handle,RGNL);
              case FBevelLabelSkinMode of
                iachbmTile :
                  begin
                    for i:=0 to dh div FBevelLabelSkin.height do
                      for j:=0 to dw div FBevelLabelSkin.width do
                        B1.canvas.Draw(j*FBevelLabelSkin.width+x1,i*FBevelLabelSkin.height+y1,FBevelLabelSkinL);
                  end;
                iachbmStretch :
                  begin
                    B1.Canvas.StretchDraw(rect(x1,y1,x1+dw,y1+dh),FBevelLabelSkinL);
                  end;  
              end;
              selectcliprgn(B1.Canvas.handle,0);
              selectcliprgn(B1.Canvas.handle,RGND);
              case FBevelLabelSkinMode of
                iachbmTile :
                  begin
                    for i:=0 to dh div FBevelLabelSkin.height do
                      for j:=0 to dw div FBevelLabelSkin.width do
                        B1.canvas.Draw(j*FBevelLabelSkin.width+x1,i*FBevelLabelSkin.height+y1,FBevelLabelSkinD);
                  end;
                iachbmStretch :
                  begin
                    B1.Canvas.StretchDraw(rect(x1,y1,x1+dw,y1+dh),FBevelLabelSkinD);
                  end;  
              end;
              selectcliprgn(B1.Canvas.handle,0);
            end;
          deleteobject(RGNL);
          deleteobject(RGND);
          //---
        end;
     // if (not FPainting) then  
      if FTransparencyPercent=0 then
        begin
          FMainBitmap.canvas.Draw(0,0,B1);
        end else
        begin
          for i:=0 to b1.Height-1 do
            begin
              p1:=B1.ScanLine[i];
              p2:=FMainBitmap.ScanLine[i];
              for j:=0 to b1.Width-1 do
                begin
                  p2[3*j]:=p2[3*j]+(p1[3*j]-p2[3*j])*(100-FTransparencyPercent) div 100;
                  p2[3*j+1]:=p2[3*j+1]+(p1[3*j+1]-p2[3*j+1])*(100-FTransparencyPercent) div 100;
                  p2[3*j+2]:=p2[3*j+2]+(p1[3*j+2]-p2[3*j+2])*(100-FTransparencyPercent) div 100;
                end;
            end;
        end;
      if FHandleType=iachtAtUp then
        begin
          if not FLabelTransparent then
            begin
              FMainBitmap.Canvas.brush.Color:=fLabelBackColor;
              FMainBitmap.Canvas.FillRect(rect(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth));
              if (FLabelSkin.Height<>0) and (FLabelSkin.width<>0) then
                begin
                  RGN:=CreaterectRGN(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth);
                  selectcliprgn(FMainBitmap.Canvas.handle,RGN);
                  case FLabelSkinMode of
                    iachbmTile :
                      begin
                        for i:=0 to (dh-2*FBeveldataDepth) div FLabelSkin.height do
                          for j:=0 to (dw-2*FBeveldataDepth) div FLabelSkin.width do
                            FMainBitmap.canvas.Draw(j*FLabelSkin.width+x1+FBeveldataDepth,i*FLabelSkin.height+y1+FBeveldataDepth,FLabelSkin);
                      end;
                    iachbmStretch :
                      begin
                        FMainBitmap.Canvas.StretchDraw(rect(x1+FBeveldataDepth,y1+FBeveldataDepth,x1+dw-FBeveldataDepth,y1+dh-FBeveldataDepth),FLabelSkin);
                      end;
                  end;
                  selectcliprgn(FMainBitmap.Canvas.handle,0);
                  deleteobject(RGN);
                end;
            end;
          FMainBitmap.canvas.Font.Assign(self.FTicksFont);
          if FDatalist.count>0 then
            begin
              FMainBitmap.Canvas.brush.style:=bsClear;
              case FIs3DLabelStyle of
                iach3dsUp :
                  begin
                    FMainBitmap.Canvas.font.color:=GetLcolor(fLabelBackColor);
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth-1,y1+FBeveldataDepth-1,FDataList[FCurrentIndex]);
                    FMainBitmap.Canvas.font.color:=GetDcolor(fLabelBackColor);
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth+1,y1+FBeveldataDepth+1,FDataList[FCurrentIndex]);
                     FMainBitmap.Canvas.font.color:=self.FTicksFont.Color;
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth,y1+FBeveldataDepth,FDataList[FCurrentIndex]);
                  end;
                iach3dsDown :
                  begin
                    FMainBitmap.Canvas.font.color:=GetDcolor(fLabelBackColor);
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth-1,y1+FBeveldataDepth-1,FDataList[FCurrentIndex]);
                    FMainBitmap.Canvas.font.color:=GetLcolor(fLabelBackColor);
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth+1,y1+FBeveldataDepth+1,FDataList[FCurrentIndex]);
                    FMainBitmap.Canvas.font.color:=self.FTicksFont.Color;
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth,y1+FBeveldataDepth,FDataList[FCurrentIndex]);
                  end;
                iach3dsShadow :
                  begin
                    FMainBitmap.Canvas.font.color:=GetDcolor(fLabelBackColor);
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth+3,y1+FBeveldataDepth+3,FDataList[FCurrentIndex]);
                    FMainBitmap.Canvas.font.color:=self.FTicksFont.Color;
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth,y1+FBeveldataDepth,FDataList[FCurrentIndex]);
                  end;
                iach3dsNone :
                  begin
                    FMainBitmap.Canvas.font.color:=self.FTicksFont.Color;
                    FMainBitmap.canvas.textout(x1+FBeveldataDepth,y1+FBeveldataDepth,FDataList[FCurrentIndex]);
                  end;
              end;
              FMainBitmap.Canvas.brush.style:=bsSolid;
            end;
        end;
      b1.free;
    end;


  // Draw the Ticks...


  
  if FTurnClockWise then
    begin
      da:=FEndPosition-FbeginPosition;
      while da<0 do inc(da,3600);
      if FDataList.Count>1 then
      da:=da div (FDataList.Count-1);
    end else
    begin
      da:=FEndPosition-FbeginPosition;
      while da>0 do dec(da,3600);
      if FDataList.Count>1 then
      da:=da div (FDataList.Count-1);
    end;
    MaxX:=0;MaxY:=0;
    FMainBitmap.canvas.Font.Assign(self.TicksFont);
  for i:=0 to  FDataList.Count-1 do
    begin
      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
      if MaxX<sz.cx then MaxX:=sz.cx;
      if MaxY<sz.cy then MaxY:=sz.cy;
    end;
  dx:=width div 2;dy:=0;
  case HandleType of
    iachtArround :
      begin
        case FCaptionPosition of
          iachcpLeftTop,iachcpRightTop :
            begin
              dy:=height-FInnerRadius-FTickLength-MaxY-FBevelDepth;
            end;
          iachcpBottomLeft,iachcpBottomRight :
            begin
              dy:=FInnerRadius+FTickLength+MaxY+FBevelDepth;
            end;
        end;
      end;
    iachtAtUp :
      begin
        case FCaptionPosition of
          iachcpLeftTop,iachcpRightTop :
            begin
              case FLabelPosition of
                iachdpLeftTop,iachdpCenterTop,iachdpRightTop :
                  begin
                    dy:=height-FInnerRadius-FTickLength-FBevelDepth;
                  end;
                iachdpLeftBottom,iachdpCenterBottom,iachdpRightBottom :
                  begin
                    dy:=height-FInnerRadius-FTickLength-FBevelDepth-MaxY-FBevelDataDepth*2-FGapData;
                  end;
              end; 
            end;
          iachcpBottomLeft,iachcpBottomRight :
            begin
              case FLabelPosition of
                iachdpLeftTop,iachdpCenterTop,iachdpRightTop :
                  begin
                    dy:=FInnerRadius+FTickLength+FBevelDepth+MaxY+FBevelDataDepth*2+FGapData;
                  end;
                iachdpLeftBottom,iachdpCenterBottom,iachdpRightBottom :
                  begin
                    dy:=FInnerRadius+FTickLength+FBevelDepth;
                  end;
              end;
            end;
        end;
      end;
  end;
  case FTicksStyle of
    iachtsAll:
      begin
        FMainBitmap.canvas.pen.width:=FTickWidth;
        case FIs3DTicksStyle of
          iach3dsUp :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetLColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))-1,dy+round(FInnerRadius*cos(a*pi/1800))-1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1+1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1+1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1+1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetLColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+1,dy+round(FInnerRadius*cos(a*pi/1800))+1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=(FTicksFont.Color);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
          iach3dsDown :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))-1,dy+round(FInnerRadius*cos(a*pi/1800))-1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1+1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1+1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1+1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetLColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+1,dy+round(FInnerRadius*cos(a*pi/1800))+1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetLColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;  

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=(FTicksFont.Color);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
          iach3dsShadow :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+3,dy+round(FInnerRadius*cos(a*pi/1800))+3);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+3,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+3);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+3;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+3;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-3-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-3)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-3-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;  

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=FTicksFont.Color;
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
          iach3dsNone :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=FTicksFont.Color;
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
        end;
        FMainBitmap.canvas.pen.width:=1;
      end;
    iachtsOdds:
      begin
        FMainBitmap.canvas.pen.width:=FTickWidth;
        case FIs3DTicksStyle of
          iach3dsUp :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetLColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800))-1)
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))-1,dy+round(FInnerRadius*cos(a*pi/1800))-1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1+1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1+1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1+1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetLColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800))+1)
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+1,dy+round(FInnerRadius*cos(a*pi/1800))+1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800)))
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=(FTicksFont.Color);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
          iach3dsDown :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800))-1)
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))-1,dy+round(FInnerRadius*cos(a*pi/1800))-1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))-1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))-1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1+1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1+1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1+1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;                          
                end;
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetLColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800))+1)
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+1,dy+round(FInnerRadius*cos(a*pi/1800))+1);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+1;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+1;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetLColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;                          
                end;  

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800)))
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=(FTicksFont.Color);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;
                end;
            end;
          iach3dsShadow :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=GetDColor(FIs3DShadowColor);
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800))+3,
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800))+3)
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800))+3,dy+round(FInnerRadius*cos(a*pi/1800))+3);
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+3,
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+3);
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800))+3;
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800))+3;
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-3-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1-3)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-3-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=GetDColor(FIs3DShadowColor);
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;                          
                end;  

              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800)))
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=FTicksFont.Color;
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;                          
                end;
            end;
          iach3dsNone :
            begin
              for i:=0 to FDataList.Count-1 do
                begin
                  FMainBitmap.canvas.pen.Color:=FTickColor;
                  a:=FBeginPosition+i*da;
                  if Odd(i) then
                  FMainBitmap.canvas.moveto(dx-round((FTickLength div 2+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength div 2+FInnerRadius)*cos(a*pi/1800)))
                  else
                  FMainBitmap.canvas.moveto(dx-round(FInnerRadius*sin(a*pi/1800)),dy+round(FInnerRadius*cos(a*pi/1800)));
                  FMainBitmap.canvas.lineto(dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800)),
                                            dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800)));
                  if FHandleType = iachtArround then
                    begin
                      x1:=dx-round((FTickLength+FInnerRadius)*sin(a*pi/1800));
                      y1:=dy+round((FTickLength+FInnerRadius)*cos(a*pi/1800));
                      GetTextExtentPoint32(FMainBitmap.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
                      if abs(x1-dx)<5 then x1:=x1-sz.cx div 2 else
                      if (X1)<dx then x1:=x1-sz.cx;
                      y1:=y1+(y1-dy-FTickLength-FInnerRadius)*MaxY div ((FTickLength+FInnerRadius)*2);
                      FMainBitmap.canvas.font.Color:=FTicksFont.Color;
                      FMainBitmap.canvas.brush.Style:=bsClear;
                      FMainBitmap.canvas.textOut(x1,y1,FDatalist[i]);
                      FMainBitmap.canvas.brush.Style:=bsSolid;
                    end;                          
                end;
            end;
        end;
        FMainBitmap.canvas.pen.width:=1;
      end;
  end;
  //Draw Handle;;;

  case FHandleStyle of
    iachhsRound :
      begin
        FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);
        FMainBitmap.canvas.pen.width:=2;
        FMainBitmap.canvas.Ellipse(dx-FInnerRadius,dy-FInnerRadius,dx+FInnerRadius,dy+FInnerRadius);
        FMainBitmap.canvas.pen.color:=GetLColor(GetLColor(Color));
        FMainBitmap.canvas.brush.color:=GetLColor(Color);

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius+3,dy-FInnerRadius+3,dx+FInnerRadius-5,dy+FInnerRadius-5);

        FMainBitmap.canvas.pen.color:=GetDColor(Color);
        FMainBitmap.canvas.brush.color:=Color;

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius+4,dy-FInnerRadius+4,dx+FInnerRadius-4,dy+FInnerRadius-4);

        FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius+7,dy-FInnerRadius+7,dx+FInnerRadius-5,dy+FInnerRadius-5);

        FMainBitmap.canvas.pen.color:=GetLColor(Color);
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius+6,dy-FInnerRadius+6,dx+FInnerRadius-6,dy+FInnerRadius-6);
        for i:=0 to 35 do
          begin
            FMainBitmap.canvas.pen.color:=(Color);
            FMainBitmap.canvas.MoveTo(dx-round((FInnerRadius-8)*sin(i*pi/18+FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius-8)*cos(i*pi/18+FCurrentPosition*pi/1800)));
            FMainBitmap.canvas.LineTo(dx,dy);
          end;
        FMainBitmap.canvas.pen.color:=GetLColor(Color);
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius-8)*sin(FCurrentPosition*pi/1800))-1,
                                  dy+round((FInnerRadius-8)*cos(FCurrentPosition*pi/1800))-1);
        FMainBitmap.canvas.pen.color:=GetDColor(Color);
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius-8)*sin(FCurrentPosition*pi/1800)+1),
                                  dy+round((FInnerRadius-8)*cos(FCurrentPosition*pi/1800))+1);
        FMainBitmap.canvas.pen.color:=FTickColor;
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius-8)*sin(FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius-8)*cos(FCurrentPosition*pi/1800)));

        for i:=0 to 35 do
          begin
            if (i<8) or (i>24) then
            FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color))
            else
            FMainBitmap.canvas.pen.color:=(Color);
            FMainBitmap.canvas.MoveTo(dx-round((FInnerRadius)*sin(i*pi/18+FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius)*cos(i*pi/18+FCurrentPosition*pi/1800)));
            FMainBitmap.canvas.LineTo(dx-round((FInnerRadius-4)*sin(i*pi/18+FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius-4)*cos(i*pi/18+FCurrentPosition*pi/1800)));
          end;

        FMainBitmap.canvas.pen.width:=1;
      end;
    iachhsLined :
      begin
        FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);
        FMainBitmap.canvas.pen.width:=2;
        FMainBitmap.canvas.Ellipse(dx-FInnerRadius,dy-FInnerRadius,dx+FInnerRadius,dy+FInnerRadius);
        for i:=0 to 35 do
          begin
            if (i<8) or (i>24) then
            FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color))
            else
            FMainBitmap.canvas.pen.color:=(Color);
            FMainBitmap.canvas.MoveTo(dx-round((FInnerRadius)*sin(i*pi/18+FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius)*cos(i*pi/18+FCurrentPosition*pi/1800)));
            FMainBitmap.canvas.LineTo(dx,dy);
          end;
         FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-3*FInnerRadius div 4+1,dy-3*FInnerRadius div 4+1,
                                   dx+3*FInnerRadius div 4-1,dy+3*FInnerRadius div 4-1);

        FMainBitmap.canvas.pen.color:=GetLColor(Color);
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-3*FInnerRadius div 4,dy-3*FInnerRadius div 4,
                                   dx+3*FInnerRadius div 4,dy+3*FInnerRadius div 4);

        FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius div 4-round((3*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800))+1,
                                   dy-FInnerRadius div 4+round((3*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800))+1,
                                   dx+FInnerRadius div 4-round((3*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800))-1,
                                   dy+FInnerRadius div 4+round((3*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800))-1);

        FMainBitmap.canvas.pen.color:=GetLColor(Color);
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx-FInnerRadius div 4-round((3*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800)),
                                   dy-FInnerRadius div 4+round((3*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800)),
                                   dx+FInnerRadius div 4-round((3*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800)),
                                   dy+FInnerRadius div 4+round((3*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800)));
        FMainBitmap.canvas.pen.color:=GetDColor(GetDColor(Color));
        FMainBitmap.canvas.brush.color:=GetDColor(Color);

        FMainBitmap.canvas.Ellipse(dx+FInnerRadius div 4+round((2*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800))+1,
                                   dy+FInnerRadius div 4-round((2*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800))+1,
                                   dx-FInnerRadius div 4+round((2*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800))-1,
                                   dy-FInnerRadius div 4-round((2*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800))-1);

        FMainBitmap.canvas.pen.color:=(Color);
        FMainBitmap.canvas.brush.color:=GetLColor(Color);

        FMainBitmap.canvas.Ellipse(dx+FInnerRadius div 4+round((2*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800)),
                                   dy+FInnerRadius div 4-round((2*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800)),
                                   dx-FInnerRadius div 4+round((2*FInnerRadius div 4)*sin(FCurrentPosition*pi/1800)),
                                   dy-FInnerRadius div 4-round((2*FInnerRadius div 4)*cos(FCurrentPosition*pi/1800)));                           


        FMainBitmap.canvas.pen.color:=GetLColor(Color);
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius)*sin(FCurrentPosition*pi/1800))-1,
                                  dy+round((FInnerRadius)*cos(FCurrentPosition*pi/1800))-1);
        FMainBitmap.canvas.pen.color:=GetDColor(Color);
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius)*sin(FCurrentPosition*pi/1800)+1),
                                  dy+round((FInnerRadius)*cos(FCurrentPosition*pi/1800))+1);
        FMainBitmap.canvas.pen.color:=FTickColor;
        FMainBitmap.canvas.MoveTo(dx,dy);
        FMainBitmap.canvas.LineTo(dx-round((FInnerRadius)*sin(FCurrentPosition*pi/1800)),
                                  dy+round((FInnerRadius)*cos(FCurrentPosition*pi/1800)));  
        FMainBitmap.canvas.pen.width:=1;  
      end;
  end;

  //

  // Draw caption
  FMainBitmap.Canvas.Font.Assign(Font);
  FMainBitmap.Canvas.brush.Style:=bsClear;
  GetTextExtentPoint32(FMainBitmap.canvas.handle,@(Caption[1]),length(Caption),sz); x0:=0;y0:=0;
  case FCaptionPosition of
    iachcpLeftTop :     begin x0:=FBevelDepth;            y0:=FBevelDepth;               end;
    iachcpRightTop :    begin x0:=width-sz.cx-FBevelDepth;y0:=FBevelDepth;               end;
    iachcpBottomLeft :  begin x0:=FBevelDepth;            y0:=height-sz.cy-FBevelDepth;  end;
    iachcpBottomRight : begin x0:=width-sz.cx-FBevelDepth;y0:=height-sz.cy-FBevelDepth;  end;
  end; 
  case FIs3DCaptionStyle of
    iach3dsUp :
      begin
        FMainBitmap.Canvas.Font.Color:=GetLColor(FIs3DShadowColor);
        FMainBitmap.Canvas.TextOut(x0-1,y0-1,Caption);
        FMainBitmap.Canvas.Font.Color:=GetDColor(FIs3DShadowColor);
        FMainBitmap.Canvas.TextOut(x0+1,y0+1,Caption);
        FMainBitmap.Canvas.Font.Color:=Font.color;
        FMainBitmap.Canvas.TextOut(x0,y0,Caption);
      end;
    iach3dsDown :
      begin
        FMainBitmap.Canvas.Font.Color:=GetDColor(FIs3DShadowColor);
        FMainBitmap.Canvas.TextOut(x0-1,y0-1,Caption);
        FMainBitmap.Canvas.Font.Color:=GetLColor(FIs3DShadowColor);
        FMainBitmap.Canvas.TextOut(x0+1,y0+1,Caption);
        FMainBitmap.Canvas.Font.Color:=Font.color;
        FMainBitmap.Canvas.TextOut(x0,y0,Caption);
      end;
    iach3dsShadow :
      begin
        FMainBitmap.Canvas.Font.Color:=GetDColor(FIs3DShadowColor);
        FMainBitmap.Canvas.TextOut(x0+3,y0+3,Caption);
        FMainBitmap.Canvas.Font.Color:=Font.color;
        FMainBitmap.Canvas.TextOut(x0,y0,Caption);
      end;
    iach3dsNone :
      begin
        FMainBitmap.Canvas.TextOut(x0,y0,Caption);
      end;
  end;
  FMainBitmap.Canvas.brush.Style:=bsSolid;
end;

procedure TIACircleHandle.FontsChanged(Sender: TObject);
begin
  NewSize;
  if sender=inherited font then
    begin
      if @FOldFontChanged<>nil then FOldFontChanged(sender);
    end else
    begin
      if sender=FTicksFont then if (@FOldTickFontChanged<>nil) then  FOldTickFontChanged(sender);
    end;
  invalidate;  
end;

function TIACircleHandle.GetCaption: string;
begin
  result:=inherited Caption;
end;

function TIACircleHandle.GetFont: TFont;
begin
  result:= inherited Font;
end;

function TIACircleHandle.GetHeight: integer;
begin
  result:=inherited Height;
end;

procedure TIACircleHandle.GetMainBitmap;
begin
  B1.Width:=Width;
  B1.Height:=Height;
  if not Fpainting then
  bitblt(B1.canvas.handle,0,0,width,height,canvas.handle,0,0,SRCCOPY);
  Canvas.Draw(0,0,FMainBitmap);
  FMainBitmap.Width:=width;
  FMainBitmap.Height:=height;
  FMainBitmap.Canvas.Draw(0,0,B1);
//  canvas.Draw(0,0,B1);
end;

procedure TIACircleHandle.GetRealSize;
var maxX,maxY,i : integer;
    sz : TSize;
    B1 : TBitmap;
begin
  B1:=TBitmap.Create;
  B1.PixelFormat:=pf24bit;
  B1.width:=width;
  B1.height:=height;
  MainSizeWithout.cx:=0;
  MainSizeWithout.cy:=0;
  case FHandleType of
    iachtArround :
      begin
        MaxX:=0;MaxY:=0;
        B1.canvas.Font.Assign(self.TicksFont);
        for i:=0 to  FDataList.Count-1 do
          begin
            GetTextExtentPoint32(B1.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
            if MaxX<sz.cx then MaxX:=sz.cx;
            if MaxY<sz.cy then MaxY:=sz.cy;
          end;
        MainSizeWithout.cx:=2*MaxX+2*FTickLength;
        MainSizeWithout.cy:=2*MaxY+2*FTickLength;
        B1.canvas.Font.Assign(self.Font);
        GetTextExtentPoint32(B1.canvas.handle,@(Caption[1]),length(caption),sz);
        if MainSizeWithout.cx<(sz.cx-2*FInnerRadius) then MainSizeWithout.cx:=(sz.cx-2*FInnerRadius);
        MainSizeWithout.cy:=MainSizeWithout.cy+sz.cy+FGapCaption;
        MainSizeWithout.cx:=MainSizeWithout.cx+FBevelDepth*2;
        MainSizeWithout.cy:=MainSizeWithout.cy+FBevelDepth*2;
      end;
    iachtAtUp  :
      begin
        MaxX:=0;MaxY:=0;
        B1.canvas.Font.Assign(self.TicksFont);
        for i:=0 to  FDataList.Count-1 do
          begin
            GetTextExtentPoint32(B1.canvas.handle,@(FDatalist[i][1]),length(FDatalist[i]),sz);
            if MaxX<sz.cx then MaxX:=sz.cx;
            if MaxY<sz.cy then MaxY:=sz.cy;
          end;
        MaxX:=MaxX+FBevelDataDepth*2;
        MaxY:=MaxY+FBevelDataDepth*2;
        MainSizeWithout.cx:=2*FTickLength;
        MainSizeWithout.cy:=2*FTickLength+FGapData+MaxY;
        if MainSizeWithout.cx<(MaxX-2*FInnerRadius) then MainSizeWithout.cx:=(MaxX-2*FInnerRadius);
        B1.canvas.Font.Assign(self.Font);
        GetTextExtentPoint32(B1.canvas.handle,@(Caption[1]),length(caption),sz);
        if MainSizeWithout.cx<(sz.cx-2*FInnerRadius) then MainSizeWithout.cx:=(sz.cx-2*FInnerRadius);
        MainSizeWithout.cy:=MainSizeWithout.cy+sz.cy+FGapCaption;
        MainSizeWithout.cx:=MainSizeWithout.cx+FBevelDepth*2;
        MainSizeWithout.cy:=MainSizeWithout.cy+FBevelDepth*2;
      end;
  end;
  B1.free;
end;

function TIACircleHandle.GetWidth: integer;
begin
  result:=inherited Width;
end;

procedure TIACircleHandle.Loaded;
begin
  inherited Loaded;
  FLoaded:=true;
  FBevelSkinL.height:=FBevelSkin.height;
  FBevelSkinL.width:=FBevelSkin.width;
  FBevelSkinL.Canvas.Draw(0,0,FBevelSkin);
  FBevelSkinD.height:=FBevelSkin.height;
  FBevelSkinD.width:=FBevelSkin.width;
  FBevelSkinD.Canvas.Draw(0,0,FBevelSkin);
  Light24Bitmap(FBevelSkinL,64);
  Dark24Bitmap(FBevelSkinD,64);
  FBevelLabelSkinL.height:=FBevelLabelSkin.height;
  FBevelLabelSkinL.width:=FBevelLabelSkin.width;
  FBevelLabelSkinL.Canvas.Draw(0,0,FBevelLabelSkin);
  FBevelLabelSkinD.height:=FBevelLabelSkin.height;
  FBevelLabelSkinD.width:=FBevelLabelSkin.width;
  FBevelLabelSkinD.Canvas.Draw(0,0,FBevelLabelSkin);
  Light24Bitmap(FBevelLabelSkinL,64);
  Dark24Bitmap(FBevelLabelSkinD,64);
end;

procedure TIACircleHandle.NewSize;
var dX,dY : integer;
begin
  GetRealSize;
  dx:=2*FInnerRadius+MainSizeWithout.cx;
  dy:=2*FInnerRadius+MainSizeWithout.cy;
  FCanResizeMe:=False;
  inherited width:=dx;
  FCanResizeMe:=False;
  inherited height:=dy;
end;

procedure TIACircleHandle.Paint;
begin
  GetMainBitmap;
  DrawMainBitmap;
  canvas.Draw(0,0,FMainBitmap);
end;

procedure TIACircleHandle.Resize;
var dX,dY : integer;
begin
if FCanResizeMe=False then
  begin
    FCanResizeMe:=True;
    inherited Resize;
    exit;
  end;
      GetRealSize;
      dx:=Width-MainSizeWithout.cx;
      dy:=Height-MainSizeWithout.cy;
      if (dx<>2*FInnerRadius) or (dy<>2*FInnerRadius) then
        begin
          if dx<dy then
            begin
              FInnerRadius:=dx div 2;

              width:=MainSizeWithout.cx+dx;
              FCanResizeMe:=False;
              height:=MainSizeWithout.cy+dx;
            end else
            begin
              FInnerRadius:=dy div 2;
              width:=MainSizeWithout.cx+dy;
              FCanResizeMe:=False;
              height:=MainSizeWithout.cy+dy;
            end;
        end else inherited Resize;
        FCanResizeMe:=TRUE;
end;

procedure TIACircleHandle.RoundPosition;
var dA,cp : integer;
begin
  if FTurnClockWise then
  begin
    da:=FEndPosition-FbeginPosition;
    while da<0 do inc(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=FCurrentPosition-FBeginPosition;
    while cp<0 do inc(cp,3600);
    cp:=da*round(cp/da)+FBeginPosition;
    while cp> 1800 do dec(cp,3600);
    while cp<=-1800 do inc(cp,3600);
    FCurrentPosition:=cp;
  end else
  begin
    da:=FEndPosition-FbeginPosition;
    while da>0 do dec(da,3600);
    if FDataList.Count>1 then
    da:=da div (FDataList.Count-1);
    cp:=FCurrentPosition-FBeginPosition;
    while cp>0 do dec(cp,3600);
    cp:=da*round(cp/da)+FBeginPosition;
    while cp> 1800 do dec(cp,3600);
    while cp<=-1800 do inc(cp,3600);
    FCurrentPosition:=cp;
  end;
end;

procedure TIACircleHandle.SetBackColor(Value: TColor);
begin
  if Value<>FBackColor then
    begin
      FBackColor := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBeginPosition(Value: Integer);
begin
  while Value> 1800 do dec(Value,3600);
  while Value<=-1800 do inc(Value,3600);
  if Value<>FBeginPosition then
    begin
      FBeginPosition := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelColor(Value: TColor);
begin
  if FBevelColor<>Value then
    begin
      FBevelColor:=Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelDataColor(Value: TColor);
begin
  if FBevelDataColor<>Value then
    begin
      FBevelDataColor:=Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBorderDataWidth(Value: integer);
begin
  if (FBorderDataWidth<>Value) and (Value>=0) and (Value<1000)  then
    begin
      FBorderDataWidth:=Value;
      GetBevelDataDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBorderWidth(Value: integer);
begin
  if (FBorderWidth<>Value) and (Value>=0) and (Value<1000)  then
    begin
      FBorderWidth:=Value;
      GetBevelDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetCaption(Value: string);
begin
  if Caption<>Value then
    begin
      inherited Caption:=Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetCaptionPosition(Value: TIACircleHandleCaptionPosition);
begin
  if Value<>FCaptionPosition then
    begin
      FCaptionPosition := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetCurrentIndex(Value: Integer);
begin
  if (Value<>FCurrentIndex) and (Value>=0) and (Value<FDataList.Count) then
    begin
      FCurrentIndex := Value;
      DefinePositionByIndex;
      if (nil<>@FOnSwitch) then FOnSwitch(self,FCurrentIndex);
      invalidate;
    end;
end;

procedure TIACircleHandle.SetCurrentPosition(Value: Integer);
var oldI : integer;
begin
  while Value> 1800 do dec(Value,3600);
  while Value<=-1800 do inc(Value,3600);
  if Value<> FCurrentPosition then
  if FMouseDown then
    begin
      oldi:=FCurrentIndex;
      FCurrentPosition := Value;
      DefineIndexByPosition;
      if (oldi<>FCurrentIndex) and (@FOnSwitch<>nil) then FOnSwitch(self,FCurrentIndex);
      FPainting:=TRUE;
      paint;
      FPainting:=false;
    end else
    begin
      oldi:=FCurrentIndex;
      FCurrentPosition := Value;
      RoundPosition;
      DefineIndexByPosition;
      if (oldi<>FCurrentIndex) and (@FOnSwitch<>nil) then FOnSwitch(self,FCurrentIndex); 
      if FLoaded then
        begin
          FPainting:=TRUE;
          paint;
          FPainting:=false;
        end else invalidate;
    end;
end;

procedure TIACircleHandle.SetDataList(Value: TStringList);
begin
  if (Value=nil) or (Value.Count=0) then
    begin
      FDataList.Clear;
      FCurrentIndex:=0;
      NewSize;
      invalidate;
    end else
    begin
      FDataList.Assign(Value);
      FCurrentIndex:=0;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetLabelPosition(Value: TIACircleHandleDataPosition);
begin
  if Value<>FLabelPosition then
    begin
      FLabelPosition := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetEndPosition(Value: Integer);
begin
  while Value> 1800 do dec(Value,3600);
  while Value<=-1800 do inc(Value,3600);
  if Value<>FEndPosition then
    begin
      FEndPosition := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetFont(Value: TFont);
begin
  inherited Font:=Value;
  NewSize;
end;

procedure TIACircleHandle.SetGapCaption(Value: integer);
begin
  if (Value<>FGapCaption) and (Value>=0) and (Value<1000) then
    begin
      FGapCaption := Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetGapData(Value: integer);
begin
  if (Value<>FGapData) and (Value>=0) and (Value<1000) then
    begin
      FGapData := Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetHandleStyle(Value: TIACircleHandleHandleStyle);
begin
  if Value<>FHandleStyle then
    begin
      FHandleStyle := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetHandleType(Value: TIACircleHandleType);
begin
  if Value<>FHandleType then
    begin
      FHandleType := Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetHeight(Value: integer);
begin
  inherited Height:=Value;
end;

procedure TIACircleHandle.SetInnerBevel(Value: TIACircleHandleBevelKind);
begin
  if (Value<>FInnerBevel) then
    begin
      FInnerBevel := Value;
      GetBevelDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetInnerBevelWidth(Value: integer);
begin
  if (Value>=0) and (Value<1000) and (Value<>FInnerBevelWidth) then
    begin
      FInnerBevelWidth := Value;
      GetBevelDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetInnerDataBevel(Value: TIACircleHandleBevelKind);
begin
  if (Value<>FInnerDataBevel) then
    begin
      FInnerDataBevel := Value;
      GetBevelDataDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetInnerDataBevelWidth(Value: integer);
begin
  if (Value>=0) and (Value<1000) and (Value<>FInnerDataBevelWidth) then
    begin
      FInnerDataBevelWidth := Value;
      GetBevelDataDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetInnerRadius(Value: integer);
begin
  if (Value>=0) and (Value<1000) and (Value<>FInnerRadius) then
    begin
      FInnerRadius := Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetIs3DCaptionStyle(Value: TIACircleHandle3DStyle);
begin
  if Value<>FIs3DCaptionStyle then
    begin
      FIs3DCaptionStyle := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetIs3DLabelStyle(Value: TIACircleHandle3DStyle);
begin
  if Value<>FIs3DLabelStyle then
    begin
      FIs3DLabelStyle := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetIs3DShadowColor( Value: TColor);
begin
  if Value<>FIs3DShadowColor then
    begin
      FIs3DShadowColor := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetIs3DTicksStyle(Value: TIACircleHandle3DStyle);
begin
  if Value<>FIs3DTicksStyle then
    begin
      FIs3DTicksStyle := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetOuterBevel(Value: TIACircleHandleBevelKind);
begin
  if (Value<>FOuterBevel) then
    begin
      FOuterBevel := Value;
      GetBevelDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetOuterBevelWidth(Value: integer);
begin
  if (Value<>FOuterBevelWidth) and (Value>=0) and (Value<1000) then
    begin
      FOuterBevelWidth := Value;
      GetBevelDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetOuterDataBevel(Value: TIACircleHandleBevelKind);
begin
  if (Value<>FOuterDataBevel) then
    begin
      FOuterDataBevel := Value;
      GetBevelDataDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetOuterDataBevelWidth(Value: integer);
begin
  if (Value<>FOuterDataBevelWidth) and (Value>=0) and (Value<1000) then
    begin
      FOuterDataBevelWidth := Value;
      GetBevelDataDepth;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTickColor(Value: TColor);
begin
  if Value<>FTickColor then
    begin
      FTickColor := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTickLength(Value: integer);
begin
  if (Value<>FTickLength) and (Value>=0) and (Value<1000) then
    begin
      FTickLength := Value;
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTicksFont(Value: TFont);
begin
  if Value=nil then
    begin
      FTicksFont.Free;
      FTicksFont:=TFont.Create;
      NewSize;
      invalidate;
    end else
    begin
      FTicksFont.Assign(Value);
      NewSize;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTicksStyle(Value: TIACircleHandleTicksStyle);
begin
  if Value<> FTicksStyle then
    begin
      FTicksStyle := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTickWidth(Value: Integer);
begin
  if (Value<> FTickWidth ) and (Value>0) and (Value<=10) then
    begin
      FTickWidth := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTransparencyPercent(Value: integer);
begin
  if (Value<> FTransparencyPercent ) and (Value>=0) and (Value<=100) then
    begin
      FTransparencyPercent := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetTurnClockWise(Value: Boolean);
begin
  if Value<> FTurnClockWise then
    begin
      FTurnClockWise := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetWidth(Value: integer);
begin
  inherited Width:=Value;
end;

procedure TIACircleHandle.WMLBUTTONDOWN(var Message: TMessage);
begin
  inherited;
  FMouseDown:=TRUE;
  FLastPosition.x:=Message.LParamLo;
  FLastPosition.y:=Message.LParamHi;
end;

procedure TIACircleHandle.WMLBUTTONUP(var Message: TMessage);
begin
  inherited;
  FMouseDown:=false;
  DefineIndexByPosition;
  RoundPosition;
  DefinePositionByIndex;
  FPainting:=TRUE;
  paint;
  FPainting:=false;
  if FInvalidateAfterMouseUp then invalidate;
end;

procedure TIACircleHandle.WMMOUSEMOVE(var Message: TMessage);
begin
  inherited;
  if FMouseDown then
  CurrentPosition:=FCurrentPosition+20*(FLastPosition.y-Message.LParamHi);
  FLastPosition.x:=Message.LParamLo;
  FLastPosition.y:=Message.LParamHi;
  Message.Result:=0;
end;



procedure TIACircleHandle.GetBevelDepth;
begin
  FBevelDepth:=FBorderWidth;
  if FInnerBevel<>iachbkNone then FBevelDepth:=FBevelDepth+FInnerBevelWidth;
  if FOuterBevel<>iachbkNone then FBevelDepth:=FBevelDepth+FOuterBevelWidth;
end;

procedure TIACircleHandle.GetBevelDataDepth;
begin
  FBevelDataDepth:=FBorderDataWidth;
  if FInnerDataBevel<>iachbkNone then FBevelDataDepth:=FBevelDataDepth+FInnerDataBevelWidth;
  if FOuterDataBevel<>iachbkNone then FBevelDataDepth:=FBevelDataDepth+FOuterDataBevelWidth;
end;

procedure TIACircleHandle.SetLabelBackColor(Value: TColor);
begin
  if Value<> FLabelBackColor then
    begin
      FLabelBackColor := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetLabelTransparent(Value: Boolean);
begin
  if Value<> FLabelTransparent then
    begin
      FLabelTransparent := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetInvalidateAfterMouseUp(Value: Boolean);
begin
  if Value<> FInvalidateAfterMouseUp then
    begin
      FInvalidateAfterMouseUp := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelLabelSkin(Value: TBitmap);
begin
  if (Value=nil) or (Value.height=0) or (Value.width=0) then
    begin
      FBevelLabelSkin.height:=0;
      FBevelLabelSkinL.height:=0;
      FBevelLabelSkinD.height:=0;
      invalidate;
    end else
    begin
      FBevelLabelSkin.height:=Value.height;
      FBevelLabelSkin.width:=Value.width;
      FBevelLabelSkin.Canvas.Draw(0,0,Value);
      FBevelLabelSkinL.height:=Value.height;
      FBevelLabelSkinL.width:=Value.width;
      FBevelLabelSkinL.Canvas.Draw(0,0,Value);
      FBevelLabelSkinD.height:=Value.height;
      FBevelLabelSkinD.width:=Value.width;
      FBevelLabelSkinD.Canvas.Draw(0,0,Value);
      Light24Bitmap(FBevelLabelSkinL,64);
      Dark24Bitmap(FBevelLabelSkinD,64);
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelSkin(Value: TBitmap);
begin
  if (Value=nil) or (Value.height=0) or (Value.width=0) then
    begin
      FBevelSkin.height:=0;
      FBevelSkinL.height:=0;
      FBevelSkinD.height:=0;
      invalidate;
    end else
    begin
      FBevelSkin.height:=Value.height;
      FBevelSkin.width:=Value.width;
      FBevelSkin.Canvas.Draw(0,0,Value);
      FBevelSkinL.height:=Value.height;
      FBevelSkinL.width:=Value.width;
      FBevelSkinL.Canvas.Draw(0,0,Value);
      FBevelSkinD.height:=Value.height;
      FBevelSkinD.width:=Value.width;
      FBevelSkinD.Canvas.Draw(0,0,Value);
      Light24Bitmap(FBevelSkinL,64);
      Dark24Bitmap(FBevelSkinD,64);
      invalidate;
    end;
end;

procedure TIACircleHandle.SetLabelSkin(Value: TBitmap);
begin
  if (Value=nil) or (Value.height=0) or (Value.width=0) then
    begin
      FLabelSkin.height:=0;
      invalidate;
    end else
    begin
      FLabelSkin.height:=Value.height;
      FLabelSkin.width:=Value.width;
      FLabelSkin.Canvas.Draw(0,0,Value);
      invalidate;
    end;
end;

procedure TIACircleHandle.SetSkin(Value: TBitmap);
begin
  if (Value=nil) or (Value.height=0) or (Value.width=0) then
    begin
      FSkin.height:=0;
      invalidate;
    end else
    begin
      FSkin.height:=Value.height;
      FSkin.width:=Value.width;
      FSkin.Canvas.Draw(0,0,Value);
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelskinMode(Value: TIACircleHandleBevelMode);
begin
  if (Value<> FBevelskinMode)then
    begin
      FBevelskinMode := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetSkinMode(Value: TIACircleHandleBevelMode);
begin
  if (Value<> FSkinMode)then
    begin
      FSkinMode := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetBevelLabelSkinMode(Value: TIACircleHandleBevelMode);
begin
  if (Value<> FBevelLabelSkinMode)then
    begin
      FBevelLabelSkinMode := Value;
      invalidate;
    end;
end;

procedure TIACircleHandle.SetLabelSkinMode(Value: TIACircleHandleBevelMode);
begin
  if (Value<> FLabelSkinMode)then
    begin
      FLabelSkinMode := Value;
      invalidate;
    end;
end;
procedure TIACircleHandle.SetOnSwitch(Value: TIACircleHandleNotifyEvent);
begin
  FOnSwitch := Value;
end;

end.
